diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 45b628142..047631c48 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1584,7 +1584,7 @@ public abstract class Entity
             return translator.translateKey(EntityDispatcher.nameKeyForClass(entity.getClass()));
         }
         NamespaceID dispatcherId = EntityDispatcher.idForClass(entity.getClass());
-        if (dispatcherId != null) return dispatcherId.value;
+        if (dispatcherId != null) return dispatcherId.value();
         return entity.getClass().getSimpleName();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 803f01fe1..74a64f93d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -43,7 +43,7 @@ public final class EntityDispatcher
         if (classToIdMap.containsKey(entityClass)) {
             throw new IllegalArgumentException("EntityDispatcher already contains an assignment for class " + entityClass.getSimpleName() + " with namespace " + classToIdMap.get(entityClass) + "!");
         }
-
+        namespaceID.makePermanent();
         classToIdMap.put(entityClass, namespaceID);
         idToClassMap.put(namespaceID, entityClass);
         stringIdToClassMap.put(namespaceID.toString(), entityClass);
@@ -179,49 +179,50 @@ public final class EntityDispatcher
         hasInit = true;
 
         // Misc
-        addMapping(EntityItem.class, new NamespaceID("minecraft", "item"));
-        addMapping(EntityPainting.class, new NamespaceID("minecraft", "painting"));
-        addMapping(EntityLightning.class, new NamespaceID("minecraft", "lightning"));
-        addMapping(EntityFallingBlock.class, new NamespaceID("minecraft", "falling_block"));
-        addMapping(EntityMinecart.class, new NamespaceID("minecraft", "minecart"));
-        addMapping(EntityBoat.class, new NamespaceID("minecraft", "boat"));
-        addMapping(EntityPrimedTNT.class, new NamespaceID("minecraft", "primed_tnt"));
+        addMapping(EntityItem.class, NamespaceID.getPermanent("minecraft", "item"));
+        addMapping(EntityPainting.class, NamespaceID.getPermanent("minecraft", "painting"));
+        addMapping(EntityLightning.class, NamespaceID.getPermanent("minecraft", "lightning"));
+        addMapping(EntityFallingBlock.class, NamespaceID.getPermanent("minecraft", "falling_block"));
+        addMapping(EntityMinecart.class, NamespaceID.getPermanent("minecraft", "minecart"));
+        addMapping(EntityBoat.class, NamespaceID.getPermanent("minecraft", "boat"));
+        addMapping(EntityPrimedTNT.class, NamespaceID.getPermanent("minecraft", "primed_tnt"));
 
         // Projectiles
-        addMapping(ProjectilePebble.class, new NamespaceID("minecraft", "pebble"));
-        addMapping(ProjectileArrow.class, new NamespaceID("minecraft", "arrow"));
-        addMapping(ProjectileArrowGolden.class, new NamespaceID("minecraft", "arrow_golden"));
-        addMapping(ProjectileArrowPurple.class, new NamespaceID("minecraft", "arrow_purple"));
-        addMapping(ProjectileSnowball.class, new NamespaceID("minecraft", "snowball"));
-        addMapping(ProjectileFireball.class, new NamespaceID("minecraft", "fireball"));
-        addMapping(ProjectileCannonball.class, new NamespaceID("minecraft", "cannonball"));
-
-        addMapping(Mob.class, new NamespaceID("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
-        addMapping(MobHuman.class, new NamespaceID("minecraft", "human"));
-        addMapping(Player.class, new NamespaceID("minecraft", "player"));
+        addMapping(ProjectilePebble.class, NamespaceID.getPermanent("minecraft", "pebble"));
+        addMapping(ProjectileArrow.class, NamespaceID.getPermanent("minecraft", "arrow"));
+        addMapping(ProjectileArrowGolden.class, NamespaceID.getPermanent("minecraft", "arrow_golden"));
+        addMapping(ProjectileArrowPurple.class, NamespaceID.getPermanent("minecraft", "arrow_purple"));
+        addMapping(ProjectileSnowball.class, NamespaceID.getPermanent("minecraft", "snowball"));
+        addMapping(ProjectileFireball.class, NamespaceID.getPermanent("minecraft", "fireball"));
+        addMapping(ProjectileCannonball.class, NamespaceID.getPermanent("minecraft", "cannonball"));
+
+        addMapping(Mob.class, NamespaceID.getPermanent("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
+        addMapping(MobHuman.class, NamespaceID.getPermanent("minecraft", "human"));
+        addMapping(Player.class, NamespaceID.getPermanent("minecraft", "player"));
 
         // Hostile
-        addMapping(MobZombie.class, new NamespaceID("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
-        addMapping(MobZombieArmored.class, new NamespaceID("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
-        addMapping(MobZombiePig.class, new NamespaceID("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
-        addMapping(MobCreeper.class, new NamespaceID("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
-        addMapping(MobSkeleton.class, new NamespaceID("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
-        addMapping(MobSpider.class, new NamespaceID("minecraft", "spider"), "guidebook.section.mob.spider.name");
-        addMapping(MobGiant.class, new NamespaceID("minecraft", "giant"));
-        addMapping(MobSlime.class, new NamespaceID("minecraft", "slime"), "guidebook.section.mob.slime.name");
-        addMapping(MobGhast.class, new NamespaceID("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
-        addMapping(MobSnowman.class, new NamespaceID("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
+        addMapping(MobZombie.class, NamespaceID.getPermanent("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
+        addMapping(MobZombieArmored.class, NamespaceID.getPermanent("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
+        addMapping(MobZombiePig.class, NamespaceID.getPermanent("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
+        addMapping(MobCreeper.class, NamespaceID.getPermanent("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
+        addMapping(MobSkeleton.class, NamespaceID.getPermanent("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
+        addMapping(MobSpider.class, NamespaceID.getPermanent("minecraft", "spider"), "guidebook.section.mob.spider.name");
+        addMapping(MobGiant.class, NamespaceID.getPermanent("minecraft", "giant"));
+        addMapping(MobSlime.class, NamespaceID.getPermanent("minecraft", "slime"), "guidebook.section.mob.slime.name");
+        addMapping(MobGhast.class, NamespaceID.getPermanent("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
+        addMapping(MobSnowman.class, NamespaceID.getPermanent("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
 
         // Passive
-        addMapping(MobScorpion.class, new NamespaceID("minecraft", "scorpion"));
-        addMapping(MobPig.class, new NamespaceID("minecraft", "pig"), "guidebook.section.mob.pig.name");
-        addMapping(MobSheep.class, new NamespaceID("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
-        addMapping(MobCow.class, new NamespaceID("minecraft", "cow"), "guidebook.section.mob.cow.name");
-        addMapping(MobChicken.class, new NamespaceID("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
-        addMapping(MobSquid.class, new NamespaceID("minecraft", "squid"), "guidebook.section.mob.squid.name");
-        addMapping(MobWolf.class, new NamespaceID("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
-        addMapping(MobFireflyCluster.class, new NamespaceID("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
-        addMapping(MobButterfly.class, new NamespaceID("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
+        addMapping(MobScorpion.class, NamespaceID.getPermanent("minecraft", "scorpion"));
+        addMapping(MobPig.class, NamespaceID.getPermanent("minecraft", "pig"), "guidebook.section.mob.pig.name");
+        addMapping(MobSheep.class, NamespaceID.getPermanent("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
+        addMapping(MobCow.class, NamespaceID.getPermanent("minecraft", "cow"), "guidebook.section.mob.cow.name");
+        addMapping(MobChicken.class, NamespaceID.getPermanent("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
+        addMapping(MobSquid.class, NamespaceID.getPermanent("minecraft", "squid"), "guidebook.section.mob.squid.name");
+        addMapping(MobWolf.class, NamespaceID.getPermanent("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
+        addMapping(MobFireflyCluster.class, NamespaceID.getPermanent("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
+        addMapping(MobButterfly.class, NamespaceID.getPermanent("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
+        addMapping(MobDeer.class, NamespaceID.getPermanent("minecraft", "deer"), "guidebook.section.mob.deer.name");
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index 2bc03d683..ed9e9b0f7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -372,21 +372,21 @@ public class EntityPainting extends Entity
             entityData.set(DATA_ITEM_METADATA_ID, (byte) 0);
         }
     }
-    private static final HashMap<String, NamespaceID> borderMaterialMap = new HashMap<>();
+    private static final HashMap<String, String> borderMaterialMap = new HashMap<>();
     public static void addBorder(ItemStack stack, NamespaceID imagePath){
-        borderMaterialMap.put(stack.itemID + "|" + stack.getMetadata(), imagePath);
+        borderMaterialMap.put(stack.itemID + "|" + stack.getMetadata(), String.format("/assets/%s/textures/art/borders/%s.png", imagePath.namespace(), imagePath.value()));
     }
-    public static NamespaceID getBorder(ItemStack stack){
+    public static String getBorder(ItemStack stack){
         return borderMaterialMap.get(stack.itemID + "|" + stack.getMetadata());
     }
     static {
-        addBorder(Items.INGOT_IRON.getDefaultStack(), new NamespaceID("minecraft", "border_iron"));
-        addBorder(Items.INGOT_GOLD.getDefaultStack(), new NamespaceID("minecraft", "border_gold"));
-        addBorder(Items.INGOT_STEEL.getDefaultStack(), new NamespaceID("minecraft", "border_steel"));
-        addBorder(new ItemStack(Items.DYE, 1, 4), new NamespaceID("minecraft", "border_lapis"));
-        addBorder(Items.DIAMOND.getDefaultStack(), new NamespaceID("minecraft", "border_diamond"));
-        addBorder(Items.DUST_REDSTONE.getDefaultStack(), new NamespaceID("minecraft", "border_redstone"));
-        addBorder(Items.OLIVINE.getDefaultStack(), new NamespaceID("minecraft", "border_olivine"));
-        addBorder(Items.QUARTZ.getDefaultStack(), new NamespaceID("minecraft", "border_quartz"));
+        addBorder(Items.INGOT_IRON.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_iron"));
+        addBorder(Items.INGOT_GOLD.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_gold"));
+        addBorder(Items.INGOT_STEEL.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_steel"));
+        addBorder(new ItemStack(Items.DYE, 1, 4), NamespaceID.getPermanent("minecraft", "border_lapis"));
+        addBorder(Items.DIAMOND.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_diamond"));
+        addBorder(Items.DUST_REDSTONE.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_redstone"));
+        addBorder(Items.OLIVINE.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_olivine"));
+        addBorder(Items.QUARTZ.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_quartz"));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index d58874bc8..ba8615728 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -100,7 +100,7 @@ public abstract class Mob extends Entity
     protected @NotNull String basePath = "/assets/minecraft/textures/entity/char/";
     protected @NotNull String defaultTexture = "/assets/minecraft/textures/entity/char/0.png";
     protected @NotNull String variantJsonPath = "/assets/minecraft/textures/entity/char/variant.json";
-    protected @NotNull NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
+    protected @NotNull NamespaceID textureIdentifier = NamespaceID.getPermanent("minecraft", "char");
 
     public boolean isSkating = false;
 
@@ -154,8 +154,8 @@ public abstract class Mob extends Entity
     }
 
     protected final void setTextureIdentifier(final  @NotNull String namespace, final @NotNull String id) {
-        this.textureIdentifier = new NamespaceID(namespace, id);
-        this.basePath = String.format("/assets/%s/textures/entity/%s/", this.textureIdentifier.namespace, this.textureIdentifier.value);
+        this.textureIdentifier = NamespaceID.getPermanent(namespace, id);
+        this.basePath = String.format("/assets/%s/textures/entity/%s/", this.textureIdentifier.namespace(), this.textureIdentifier.value());
         this.defaultTexture = this.basePath + "0.png";
         this.variantJsonPath = this.basePath + "variants.json";
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
index c8793e3e7..189ea6dde 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
@@ -56,7 +56,7 @@ public abstract class MobAnimal extends MobPathfinder
         if(world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
             return 8;
         if(world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
-            return 1;
+            return 0;
         return 4;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
new file mode 100644
index 000000000..d368c873f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
@@ -0,0 +1,85 @@
+package net.minecraft.core.entity.animal;
+
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.entity.AgedMob;
+import net.minecraft.core.entity.MobAge;
+import net.minecraft.core.item.Items;
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.NotNull;
+
+public class MobDeer
+        extends MobAnimal
+        implements AgedMob
+{
+    private final @NotNull MobAge age;
+
+    public MobDeer(World world)
+    {
+        super(world);
+        setTextureIdentifier("minecraft", "deer");
+        setSize(0.9F, 1.3F);
+        mobDrops.add(new WeightedRandomLootObject(Items.FOOD_VENISON_RAW.getDefaultStack(), 1, 2));
+        this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 5, 14, MobAge.YEAR_LENGTH_DAYS * 4);
+    }
+
+    @Override
+    public void onLivingUpdate() {
+        super.onLivingUpdate();
+
+        this.getMobAge().tick(this.world);
+    }
+
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
+    }
+
+    @Override
+    public void addAdditionalSaveData(@NotNull CompoundTag tag)
+    {
+        super.addAdditionalSaveData(tag);
+
+        this.age.writeTag(tag);
+    }
+
+    @Override
+    public int getMaxSpawnedInChunk()
+    {
+        if(world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
+            return 4;
+        return 0;
+    }
+
+    @Override
+    public void readAdditionalSaveData(@NotNull CompoundTag tag)
+    {
+        super.readAdditionalSaveData(tag);
+
+        this.age.readTag(tag);
+    }
+
+    //Todo: change with new sounds
+    @Override
+    public String getLivingSound()
+    {
+        return "mob.cow";
+    }
+    @Override
+    protected String getHurtSound()
+    {
+        return "mob.cowhurt";
+    }
+    @Override
+    protected String getDeathSound()
+    {
+        return "mob.cowhurt";
+    }
+
+    @Override
+    protected float getSoundVolume()
+    {
+        return 0.4F;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java b/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
index abd5d27ef..0b33796b0 100644
--- a/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
+++ b/game/core/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.enums;
 
+import org.jetbrains.annotations.Nullable;
+
 public enum EnumSignPicture
 {
     NONE                (0,  "sign.image.none",             "minecraft:sign/none"),
@@ -48,6 +50,7 @@ public enum EnumSignPicture
     CHECK               (43, "sign.image.check",            "minecraft:sign/check"),
     EXIT                (44, "sign.image.exit",             "minecraft:sign/exit");
 
+    private static EnumSignPicture[] vals = values();
     private final int id;
     private final String languageKey;
     private final String texKey;
@@ -73,4 +76,9 @@ public enum EnumSignPicture
     {
         return texKey;
     }
+
+    public static @Nullable EnumSignPicture fromId(int id) {
+        if (id < 0 || id >= vals.length) return null;
+        return vals[id];
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 742178d66..a68fd0060 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -60,7 +60,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
         hasSubtypes = false;
         containerItem = null;
         this.id = id;
-        this.namespaceID = namespaceId;
+        this.namespaceID = namespaceId.makePermanent();
         if (itemsList[id] != null) {
             throw new IllegalArgumentException("Item slot '" + id + "' is already occupied by '" + itemsList[id] + "' when adding " + this);
         }
@@ -82,7 +82,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
 
     private static NamespaceID makeNamespaceID(String string){ // This exists because java is idiotic
         try {
-            return new NamespaceID(string);
+            return NamespaceID.getPermanent(string);
         } catch (HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
@@ -98,7 +98,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
                 stat = replaceItem.createStat(statID, nameKey);
             }
         } else {
-            stat = new StatItem(new NamespaceID(namespaceID.namespace, namespaceID.value + "_" + statID), nameKey, id).registerStat();
+            stat = new StatItem(NamespaceID.getPermanent(namespaceID.namespace(), namespaceID.value() + "_" + statID), nameKey, id).registerStat();
         }
 
         putStat(statID, stat);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index 027ca73f6..b2135f0bd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item;
 
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -57,8 +58,12 @@ public class ItemSign extends Item
         TileEntitySign tileentitysign = (TileEntitySign)world.getTileEntity(blockX, blockY, blockZ);
         if(tileentitysign != null)
         {
-            tileentitysign.setOwner(player);
-            player.displaySignEditorScreen(tileentitysign);
+            if (itemstack.getData().containsKey("tileEntityData")) {
+                tileentitysign.readAdditionalData(itemstack.getData().getCompound("tileEntityData"));
+            } else {
+                tileentitysign.setOwner(player);
+                player.displaySignEditorScreen(tileentitysign);
+            }
         }
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
index 3a00fd3ae..73e762e31 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -55,8 +55,12 @@ public class ItemSignPainted extends ItemSign{
         TileEntitySign tileentitysign = (TileEntitySign)world.getTileEntity(blockX, blockY, blockZ);
         if(tileentitysign != null)
         {
-            tileentitysign.setOwner(player);
-            player.displaySignEditorScreen(tileentitysign);
+            if (itemstack.getData().containsKey("tileEntityData")) {
+                tileentitysign.readAdditionalData(itemstack.getData().getCompound("tileEntityData"));
+            } else {
+                tileentitysign.setOwner(player);
+                player.displaySignEditorScreen(tileentitysign);
+            }
         }
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 8b55d1ad4..96c21f50a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -86,6 +86,8 @@ public final class Items {
     public static Item FLINT;
     public static Item FOOD_PORKCHOP_RAW;
     public static Item FOOD_PORKCHOP_COOKED;
+    public static Item FOOD_VENISON_RAW;
+    public static Item FOOD_VENISON_COOKED;
     public static Item PAINTING;
     public static Item FOOD_APPLE_GOLD;
     public static Item SIGN;
@@ -422,5 +424,7 @@ public final class Items {
         STATUE_MARBLE = new ItemStatue("statue.marble", "minecraft:item/statue_marble", 16547, Blocks.STATUE_MARBLE_LOWER, Blocks.STATUE_MARBLE_UPPER);
         STATUE_PIGMAN = new ItemStatue("statue.pigman", "minecraft:item/statue_pigman", 16548, Blocks.STATUE_PIGMAN_LOWER, Blocks.STATUE_PIGMAN_UPPER);
         SIGN_PAINTED = (new ItemSignPainted("sign.painted", "minecraft:item/sign_painted", 16549));
+        FOOD_VENISON_RAW = (new ItemFood("food.venison.raw", "minecraft:item/food_venison_raw", 16550, 3, 16, true, 4));
+        FOOD_VENISON_COOKED = (new ItemFood("food.venison.cooked", "minecraft:item/food_venison_cooked", 16551, 12, 8, true, 4));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java b/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
index d3dd6792a..33b9a23ca 100644
--- a/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
+++ b/game/core/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
@@ -31,7 +31,7 @@ public class ArmorMaterial {
 	private final Map<DamageType, Float> protection = new HashMap<>();
 	
 	public ArmorMaterial(NamespaceID identifier, int durability) {
-		this.identifier = identifier;
+		this.identifier = identifier.makePermanent();
 		this.durability = durability;
 
 		ARMOR_MATERIALS.add(this);
@@ -50,37 +50,37 @@ public class ArmorMaterial {
 		return this;
 	}
 	
-	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(new NamespaceID("minecraft", "cloth"), 180)
+	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "cloth"), 180)
 		.withProtectionPercentage(COMBAT, 20.0f)
 		.withProtectionPercentage(BLAST, 20.0f)
 		.withProtectionPercentage(FIRE, 20.0f)
 		.withProtectionPercentage(FALL, 120.0f)
 	);
-	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(new NamespaceID("minecraft", "chain"), 240)
+	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "chain"), 240)
 		.withProtectionPercentage(COMBAT, 120.0f)
 		.withProtectionPercentage(BLAST, 35.0f)
 		.withProtectionPercentage(FIRE, 35.0f)
 		.withProtectionPercentage(FALL, 35.0f)
 	);
-	public static final ArmorMaterial IRON = register(new ArmorMaterial(new NamespaceID("minecraft", "iron"), 200)
+	public static final ArmorMaterial IRON = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "iron"), 200)
 		.withProtectionPercentage(COMBAT, 45.0f)
 		.withProtectionPercentage(BLAST, 45.0f)
 		.withProtectionPercentage(FIRE, 45.0f)
 		.withProtectionPercentage(FALL, 45.0f)
 	);
-	public static final ArmorMaterial GOLD = register(new ArmorMaterial(new NamespaceID("minecraft", "gold"), 120)
+	public static final ArmorMaterial GOLD = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "gold"), 120)
 		.withProtectionPercentage(COMBAT, 70.0f)
 		.withProtectionPercentage(BLAST, 70.0f)
 		.withProtectionPercentage(FIRE, 70.0f)
 		.withProtectionPercentage(FALL, 70.0f)
 	);
-	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(new NamespaceID("minecraft", "diamond"), 800)
+	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "diamond"), 800)
 		.withProtectionPercentage(COMBAT, 66.0f)
 		.withProtectionPercentage(BLAST, 66.0f)
 		.withProtectionPercentage(FIRE, 124.0f)
 		.withProtectionPercentage(FALL, 66.0f)
 	);
-	public static final ArmorMaterial STEEL = register(new ArmorMaterial(new NamespaceID("minecraft", "steel"), 1200)
+	public static final ArmorMaterial STEEL = register(new ArmorMaterial(NamespaceID.getPermanent("minecraft", "steel"), 1200)
 		.withProtectionPercentage(COMBAT, 55.0f)
 		.withProtectionPercentage(BLAST, 150.0f)
 		.withProtectionPercentage(FIRE, 55.0f)
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
index d28681588..190b8c2bf 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
@@ -17,7 +17,7 @@ import java.util.function.Consumer;
 
 public class BlockArgumentParser extends ArgumentParser {
     private static final SimpleCommandExceptionType INVALID_BLOCK = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
-    public static final NamespaceID AIR_BLOCK = new NamespaceID("minecraft", "block/air");
+    public static final NamespaceID AIR_BLOCK = NamespaceID.getPermanent("minecraft", "block/air");
     private Block<?> block;
     private int metadata = 0;
     private CompoundTag tag = new CompoundTag();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
index c5dad2470..5bca2e9ec 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
@@ -116,11 +116,11 @@ public class EntitySelectorOptions {
                 CommandHelper.suggest("!Player", builder);
                 CommandHelper.suggest("Player", builder);
                 for (NamespaceID key : EntityDispatcher.idToClassMap.keySet()) {
-                    if (!(key.toString().startsWith(string) || (key.namespace.equals("minecraft") && key.value.startsWith(string)))) continue;
+                    if (!(key.toString().startsWith(string) || (key.namespace().equals("minecraft") && key.value().startsWith(string)))) continue;
                     CommandHelper.suggest("!" + key, builder);
                     if (invert) continue;
-                    if (key.namespace.equals("minecraft")) {
-                        CommandHelper.suggest(key.value, builder);
+                    if (key.namespace().equals("minecraft")) {
+                        CommandHelper.suggest(key.value(), builder);
                     }
                     CommandHelper.suggest(key.toString(), builder);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
index 74575ed23..81c487f46 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
@@ -94,8 +94,8 @@ public class CommandHelper {
     public static boolean matchesNamespaceId(NamespaceID namespaceID, String input) {
         if (input.contains(":")) {
             return namespaceID.toString().equalsIgnoreCase(input);
-        } else if (namespaceID.namespace.equals("minecraft")) {
-            return namespaceID.value.equalsIgnoreCase(input);
+        } else if (namespaceID.namespace().equals("minecraft")) {
+            return namespaceID.value().equalsIgnoreCase(input);
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
index a71558d9b..6b76a85e4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
@@ -34,7 +34,7 @@ public class PacketStatistic extends Packet
         throws IOException
     {
         try {
-            statID = new NamespaceID(readStringUTF8(dis, Integer.MAX_VALUE));
+            statID = NamespaceID.getTemp(readStringUTF8(dis, Integer.MAX_VALUE));
         } catch (HardIllegalArgumentException e) {
             statID = null;
         }
